#ifndef SADIE_INDEX_H
#define SADIE_INDEX_H 1
#include "project_utilities.h"

BEGIN_C_DECLARATIONS

typedef void (*sad_property_data_destructor_t) (void *);

typedef struct Sad_doclist * sad_doclistp_t;

void dispose_doclist (sad_doclistp_t thedoclist);

sad_doclistp_t make_doclist (int logsize);

int sad_dispose_doc (sad_doclistp_t doclist, const char *dkey);

int sad_put_doc (sad_doclistp_t doclist, const char *dkey,
                 int logpsize, const IMAGE *img);

int sad_put_doc_property (sad_doclistp_t doclist, const char *dkey,
                          const char *pkey,
                          sad_property_data_destructor_t destruct,
                          void *data);

void * sad_get_doc_property (const sad_doclistp_t doclist,
                             const char *dkey, const char *pkey);

END_C_DECLARATIONS

#endif /* !SADIE_INDEX_H */
